PRINT "CASEREPL - replacing strings by position."
ver$ = "1.0"
apo$ = "'"'CHR$(34)
PRINT "(C) Jost Jahn, Version " + ver$ + " 2007 March 19."
PRINT "See http://www.jostjahn.de/software/caserepl.html"
'
' File bergeben.
zeile$ = LTRIM$(RTRIM$(COMMAND$))
orizeile$=zeile$
'
' Hilfe?
IF zeile$ = SPACE$(LEN(file$)) THEN
  PRINT
  PRINT "CASEREPL file ";
  PRINT "search ";
  PRINT "find ";
  PRINT "before ";
  PRINT "after "
  PRINT "file is the file to work with."
  PRINT "search is the search string."
  PRINT "find is the decision string."
  PRINT "before is the string to replace search before find string."
  PRINT "after is the string to replace search after find string."
  PRINT "If you use a blank in one parameter,"
  PRINT "you must use ' at begin and end."
  PRINT "You can't search for apostrophes."
  CLOSE
  END
END IF
'
' Trennen der Parameter.
'
' Datei
IF LEFT$(zeile$, 1) = apo$ THEN
  wo = INSTR(2,zeile$, apo$)
ELSE
  wo = INSTR(zeile$, " ")
END IF
IF wo = 0 THEN
  PRINT "Too less parameters at file parsing."
  STOP
ELSE
  wert$ = LEFT$(zeile$, wo - 1)
  zeile$ = LTRIM$(MID$(zeile$, wo + 1))
  IF LEFT$(wert$, 1) = apo$ THEN wert$ = MID$(wert$, 2)
  IF LEFT$(zeile$, 1) = " " THEN zeile$ = MID$(zeile$, 2)
END IF
file$ = wert$
'
' Suche.
IF LEFT$(zeile$, 1) = apo$ THEN
  wo = INSTR(2,zeile$, apo$)
ELSE
  wo = INSTR(zeile$, " ")
END IF
IF wo = 0 THEN
  PRINT "Too less parameters at search parsing."
  STOP
ELSE
  wert$ = LEFT$(zeile$, wo - 1)
  zeile$ = LTRIM$(MID$(zeile$, wo + 1))
  IF LEFT$(wert$, 1) = apo$ THEN wert$ = MID$(wert$, 2)
  IF LEFT$(zeile$, 1) = " " THEN zeile$ = MID$(zeile$, 2)
END IF
search$ = wert$
'
' Finde.
IF LEFT$(zeile$, 1) = apo$ THEN
  wo = INSTR(2,zeile$, apo$)
ELSE
  wo = INSTR(zeile$, " ")
END IF
IF wo = 0 THEN
  PRINT "Too less parameters at find parsing."
  STOP
ELSE
  wert$ = LEFT$(zeile$, wo - 1)
  zeile$ = LTRIM$(MID$(zeile$, wo + 1))
  IF LEFT$(wert$, 1) = apo$ THEN wert$ = MID$(wert$, 2)
  IF LEFT$(zeile$, 1) = " " THEN zeile$ = MID$(zeile$, 2)
END IF
find$ = wert$
'
' Vorher und Hinterher zu ersetzen.
IF LEFT$(zeile$, 1) = apo$ THEN
  wo = INSTR(2,zeile$, apo$)
ELSE
  wo = INSTR(zeile$, " ")
END IF
IF wo = 0 THEN
  PRINT "Too less parameters at before/after parsing."
  STOP
ELSE
  wert$ = LEFT$(zeile$, wo - 1)
  zeile$ = MID$(zeile$, wo + 1)
  IF LEFT$(wert$, 1) = apo$ THEN wert$ = MID$(wert$, 2)
  IF LEFT$(zeile$, 1) = " " THEN zeile$ = MID$(zeile$, 2)
END IF
before$ = wert$
after$ = zeile$
IF LEFT$(after$,1)=apo$ THEN after$=MID$(after$,2)
IF RIGHT$(after$,1)=apo$ THEN after$=LEFT$(after$,LEN(after$)-1)
'
' Protokoll
PRINT "File:   " +apo$+file$+apo$
PRINT "Search: " +apo$+search$+apo$
PRINT "Find:   " +apo$+find$+apo$
PRINT "Before: " +apo$+before$+apo$
PRINT "After:  " +apo$+after$+apo$

'
' Pruefen auf Existenz.
OPEN file$ FOR APPEND AS #1
IF LOF(1) = 0 THEN
  CLOSE 1
  KILL file$
  PRINT "The input file " + file$ + " doesn't exist or is empty. STOP."
  STOP
  END
END IF
CLOSE 1
OPEN file$ FOR INPUT AS #1
OPEN "casereplace.out" FOR OUTPUT AS #2
'
' Ueber alle Zeilen.
before=0
after=0
search=0
finde=0
zeile=0
linie=0
WHILE NOT EOF(1)
  '
  ' Zeile lesen.
  LINE INPUT #1, zeile$
  orizeile$=zeile$
  '
  ' Ueber alle Ersetzer.
  wo=1
  zeile=zeile+1
  ersetzt=0
  DO
    '
    ' Gefunden?
    wo=INSTR(wo,zeile$,search$)
    IF wo>0 THEN
      search=search+1
      '
      ' Finde auch da?
      dort=INSTR(zeile$,find$)
      IF dort<wo THEN
        finde=finde+1
        '
        ' Ersetzen nach Ort.
        zeile$=LEFT$(zeile$,wo-1)+after$+MID$(zeile$,wo+LEN(search$))
        wo=wo+LEN(after$)
        after=after+1
      ELSE
        '
        ' Ersetzen berall.
        zeile$=LEFT$(zeile$,wo-1)+before$+MID$(zeile$,wo+LEN(search$))
        wo=wo+LEN(before$)
        before=before+1
      END IF
      linie=linie+1
      ersetzt=1
    END IF
  LOOP UNTIL wo=0
  PRINT #2,zeile$
WEND
'
' Schluss und Ende.
CLOSE
PRINT "Lines total: ";zeile
PRINT "Lines found: ";linie
PRINT "Found:       ";search
PRINT "Lines limit: ";finde
PRINT "After:       ";after
PRINT "Before:      ";before
END

